Index: palm/trunk/SOURCE/data_output_netcdf4_module.f90
===================================================================
--- palm/trunk/SOURCE/data_output_netcdf4_module.f90	(revision 4146)
+++ palm/trunk/SOURCE/data_output_netcdf4_module.f90	(revision 4147)
@@ -556,193 +560,201 @@
 
 #if defined( __parallel )
-   CALL MPI_COMM_RANK( output_group_comm, my_rank, return_value )
-   IF ( return_value /= 0 )  THEN
-      CALL internal_message( 'error', routine_name // ': MPI_COMM_RANK error' )
-   ENDIF
-#else
-   my_rank = master_rank
-   return_value = 0
-#endif
-
-   IF ( return_value == 0  .AND.  ( .NOT. is_global  .OR.  my_rank == master_rank ) )  THEN
-
-      WRITE( temp_string, * ) variable_id
-      CALL internal_message( 'debug', routine_name // ': write variable ' // TRIM( temp_string ) )
-
-      ndims = SIZE( bounds_start )
-
-      !-- 8bit integer output
-      IF ( PRESENT( values_int8_0d ) )  THEN
-         nc_stat = NF90_PUT_VAR( file_id, variable_id, (/ values_int8_0d /), &
-                                 start = bounds_start - bounds_origin + 1,   &
-                                 count = value_counts )
-      ELSEIF ( PRESENT( values_int8_1d ) )  THEN
-         nc_stat = NF90_PUT_VAR( file_id, variable_id, values_int8_1d,     &
-                                 start = bounds_start - bounds_origin + 1, &
-                                 count = value_counts )
-      ELSEIF ( PRESENT( values_int8_2d ) )  THEN
-         nc_stat = NF90_PUT_VAR( file_id, variable_id, values_int8_2d,     &
-                                 start = bounds_start - bounds_origin + 1, &
-                                 count = value_counts )
-      ELSEIF ( PRESENT( values_int8_3d ) )  THEN
-         nc_stat = NF90_PUT_VAR( file_id, variable_id, values_int8_3d,     &
-                                 start = bounds_start - bounds_origin + 1, &
-                                 count = value_counts )
-      !-- 16bit integer output
-      ELSEIF ( PRESENT( values_int16_0d ) )  THEN
-         nc_stat = NF90_PUT_VAR( file_id, variable_id, (/ values_int16_0d /), &
-                                 start = bounds_start - bounds_origin + 1,    &
-                                 count = value_counts )
-      ELSEIF ( PRESENT( values_int16_1d ) )  THEN
-         nc_stat = NF90_PUT_VAR( file_id, variable_id, values_int16_1d,    &
-                                 start = bounds_start - bounds_origin + 1, &
-                                 count = value_counts )
-      ELSEIF ( PRESENT( values_int16_2d ) )  THEN
-         nc_stat = NF90_PUT_VAR( file_id, variable_id, values_int16_2d,    &
-                                 start = bounds_start - bounds_origin + 1, &
-                                 count = value_counts )
-      ELSEIF ( PRESENT( values_int16_3d ) )  THEN
-         nc_stat = NF90_PUT_VAR( file_id, variable_id, values_int16_3d,    &
-                                 start = bounds_start - bounds_origin + 1, &
-                                 count = value_counts )
-      !-- 32bit integer output
-      ELSEIF ( PRESENT( values_int32_0d ) )  THEN
-         nc_stat = NF90_PUT_VAR( file_id, variable_id, (/ values_int32_0d /),  &
-                                 start = bounds_start - bounds_origin + 1,     &
-                                 count = value_counts )
-      ELSEIF ( PRESENT( values_int32_1d ) )  THEN
-         nc_stat = NF90_PUT_VAR( file_id, variable_id, values_int32_1d,    &
-                                 start = bounds_start - bounds_origin + 1, &
-                                 count = value_counts )
-      ELSEIF ( PRESENT( values_int32_2d ) )  THEN
-         nc_stat = NF90_PUT_VAR( file_id, variable_id, values_int32_2d,    &
-                                 start = bounds_start - bounds_origin + 1, &
-                                 count = value_counts )
-      ELSEIF ( PRESENT( values_int32_3d ) )  THEN
-         nc_stat = NF90_PUT_VAR( file_id, variable_id, values_int32_3d,    &
-                                 start = bounds_start - bounds_origin + 1, &
-                                 count = value_counts )
-      !-- working-precision integer output
-      ELSEIF ( PRESENT( values_intwp_0d ) )  THEN
-         nc_stat = NF90_PUT_VAR( file_id, variable_id, (/ values_intwp_0d /),  &
-                                 start = bounds_start - bounds_origin + 1,     &
-                                 count = value_counts )
-      ELSEIF ( PRESENT( values_intwp_1d ) )  THEN
-         nc_stat = NF90_PUT_VAR( file_id, variable_id, values_intwp_1d,    &
-                                 start = bounds_start - bounds_origin + 1, &
-                                 count = value_counts )
-      ELSEIF ( PRESENT( values_intwp_2d ) )  THEN
-         nc_stat = NF90_PUT_VAR( file_id, variable_id, values_intwp_2d,    &
-                                 start = bounds_start - bounds_origin + 1, &
-                                 count = value_counts )
-      ELSEIF ( PRESENT( values_intwp_3d ) )  THEN
-         nc_stat = NF90_PUT_VAR( file_id, variable_id, values_intwp_3d,    &
-                                 start = bounds_start - bounds_origin + 1, &
-                                 count = value_counts )
-      !-- 32bit real output
-      ELSEIF ( PRESENT( values_real32_0d ) )  THEN
-         nc_stat = NF90_PUT_VAR( file_id, variable_id, (/ values_real32_0d /), &
-                                 start = bounds_start - bounds_origin + 1,     &
-                                 count = value_counts )
-      ELSEIF ( PRESENT( values_real32_1d ) )  THEN
-         nc_stat = NF90_PUT_VAR( file_id, variable_id, values_real32_1d,   &
-                                 start = bounds_start - bounds_origin + 1, &
-                                 count = value_counts )
-      ELSEIF ( PRESENT( values_real32_2d ) )  THEN
-         nc_stat = NF90_PUT_VAR( file_id, variable_id, values_real32_2d,   &
-                                 start = bounds_start - bounds_origin + 1, &
-                                 count = value_counts )
-      ELSEIF ( PRESENT( values_real32_3d ) )  THEN
-         nc_stat = NF90_PUT_VAR( file_id, variable_id, values_real32_3d,   &
-                                 start = bounds_start - bounds_origin + 1, &
-                                 count = value_counts )
-      !-- 64bit real output
-      ELSEIF ( PRESENT( values_real64_0d ) )  THEN
-         nc_stat = NF90_PUT_VAR( file_id, variable_id, (/ values_real64_0d /), &
-                                 start = bounds_start - bounds_origin + 1,     &
-                                 count = value_counts )
-      ELSEIF ( PRESENT( values_real64_1d ) )  THEN
-         nc_stat = NF90_PUT_VAR( file_id, variable_id, values_real64_1d,   &
-                                 start = bounds_start - bounds_origin + 1, &
-                                 count = value_counts )
-      ELSEIF ( PRESENT( values_real64_2d ) )  THEN
-         nc_stat = NF90_PUT_VAR( file_id, variable_id, values_real64_2d,   &
-                                 start = bounds_start - bounds_origin + 1, &
-                                 count = value_counts )
-      ELSEIF ( PRESENT( values_real64_3d ) )  THEN
-         nc_stat = NF90_PUT_VAR( file_id, variable_id, values_real64_3d,   &
-                                 start = bounds_start - bounds_origin + 1, &
-                                 count = value_counts )
-      !-- working-precision real output
-      ELSEIF ( PRESENT( values_realwp_0d ) )  THEN
-         nc_stat = NF90_PUT_VAR( file_id, variable_id, (/ values_realwp_0d /), &
-                                 start = bounds_start - bounds_origin + 1,     &
-                                 count = value_counts )
-      ELSEIF ( PRESENT( values_realwp_1d ) )  THEN
-         nc_stat = NF90_PUT_VAR( file_id, variable_id, values_realwp_1d,   &
-                                 start = bounds_start - bounds_origin + 1, &
-                                 count = value_counts )
-      ELSEIF ( PRESENT( values_realwp_2d ) )  THEN
-         nc_stat = NF90_PUT_VAR( file_id, variable_id, values_realwp_2d,   &
-                                 start = bounds_start - bounds_origin + 1, &
-                                 count = value_counts )
-      ELSEIF ( PRESENT( values_realwp_3d ) )  THEN
-         nc_stat = NF90_PUT_VAR( file_id, variable_id, values_realwp_3d,   &
-                                 start = bounds_start - bounds_origin + 1, &
-                                 count = value_counts )
-      ELSE
-         return_value = 1
-         nc_stat = NF90_NOERR
-         WRITE( temp_string, '(": variable_id=",I6,", file_id=",I6)' ) variable_id, file_id
-         CALL internal_message( 'error', routine_name // &
-                                ': no output values given ' // TRIM( temp_string ) )
-      ENDIF
-
-      !-- Check for errors
-      IF ( nc_stat /= NF90_NOERR )  THEN
-         return_value = 1
-
-         IF ( nc_stat == NF90_EEDGE .OR. nc_stat == NF90_EINVALCOORDS )  THEN
-
-            !-- If given bounds exceed dimension bounds, get information of bounds in file
-            WRITE( temp_string, * )  NF90_STRERROR( nc_stat )
-
-            ALLOCATE( dimension_ids(ndims) )
-            ALLOCATE( dimension_lengths(ndims) )
-
-            nc_stat = NF90_INQUIRE_VARIABLE( file_id, variable_id, dimids=dimension_ids )
-
-            d = 1
-            DO WHILE ( d <= ndims .AND. nc_stat == NF90_NOERR )
-               nc_stat = NF90_INQUIRE_DIMENSION( file_id, dimension_ids(d), &
-                                                 LEN=dimension_lengths(d) )
-               d = d + 1
-            ENDDO
-
-            IF ( nc_stat == NF90_NOERR )  THEN
-               WRITE( temp_string, * )  TRIM( temp_string ) // '; given variable bounds: ' //  &
-                  'start=', bounds_start, ', count=', value_counts, ', origin=', bounds_origin
-               CALL internal_message( 'error', routine_name //     &
-                                      ': error while writing: ' // TRIM( temp_string ) )
-            ELSE
-               !-- Error occured during NF90_INQUIRE_VARIABLE or NF90_INQUIRE_DIMENSION
-               CALL internal_message( 'error', routine_name //            &
-                                      ': error while accessing file: ' // &
-                                       NF90_STRERROR( nc_stat ) )
-            ENDIF
-
-         ELSE
-            !-- Other NetCDF error
-            CALL internal_message( 'error', routine_name //     &
-                                   ': error while writing: ' // NF90_STRERROR( nc_stat ) )
-         ENDIF
-      ENDIF
-
-   ENDIF
-#else
-   return_value = 1
-#endif
-
-END SUBROUTINE netcdf4_write_variable
+    CALL MPI_COMM_RANK( output_group_comm, my_rank, return_value )
+    IF ( return_value /= 0 )  THEN
+       CALL internal_message( 'error', routine_name // ': MPI_COMM_RANK error' )
+    ENDIF
+#else
+    my_rank = master_rank
+    return_value = 0
+#endif
+
+    IF ( return_value == 0  .AND.  ( .NOT. is_global  .OR.  my_rank == master_rank ) )  THEN
+
+       WRITE( temp_string, * ) variable_id
+       CALL internal_message( 'debug', routine_name // ': write variable ' // TRIM( temp_string ) )
+
+       ndims = SIZE( bounds_start )
+!
+!--    8bit integer output
+       IF ( PRESENT( values_int8_0d ) )  THEN
+          nc_stat = NF90_PUT_VAR( file_id, variable_id, (/ values_int8_0d /), &
+                                  start = bounds_start - bounds_origin + 1,   &
+                                  count = value_counts )
+       ELSEIF ( PRESENT( values_int8_1d ) )  THEN
+          nc_stat = NF90_PUT_VAR( file_id, variable_id, values_int8_1d,     &
+                                  start = bounds_start - bounds_origin + 1, &
+                                  count = value_counts )
+       ELSEIF ( PRESENT( values_int8_2d ) )  THEN
+          nc_stat = NF90_PUT_VAR( file_id, variable_id, values_int8_2d,     &
+                                  start = bounds_start - bounds_origin + 1, &
+                                  count = value_counts )
+       ELSEIF ( PRESENT( values_int8_3d ) )  THEN
+          nc_stat = NF90_PUT_VAR( file_id, variable_id, values_int8_3d,     &
+                                  start = bounds_start - bounds_origin + 1, &
+                                  count = value_counts )
+!
+!--    16bit integer output
+       ELSEIF ( PRESENT( values_int16_0d ) )  THEN
+          nc_stat = NF90_PUT_VAR( file_id, variable_id, (/ values_int16_0d /), &
+                                  start = bounds_start - bounds_origin + 1,    &
+                                  count = value_counts )
+       ELSEIF ( PRESENT( values_int16_1d ) )  THEN
+          nc_stat = NF90_PUT_VAR( file_id, variable_id, values_int16_1d,    &
+                                  start = bounds_start - bounds_origin + 1, &
+                                  count = value_counts )
+       ELSEIF ( PRESENT( values_int16_2d ) )  THEN
+          nc_stat = NF90_PUT_VAR( file_id, variable_id, values_int16_2d,    &
+                                  start = bounds_start - bounds_origin + 1, &
+                                  count = value_counts )
+       ELSEIF ( PRESENT( values_int16_3d ) )  THEN
+          nc_stat = NF90_PUT_VAR( file_id, variable_id, values_int16_3d,    &
+                                  start = bounds_start - bounds_origin + 1, &
+                                  count = value_counts )
+!
+!--    32bit integer output
+       ELSEIF ( PRESENT( values_int32_0d ) )  THEN
+          nc_stat = NF90_PUT_VAR( file_id, variable_id, (/ values_int32_0d /),  &
+                                  start = bounds_start - bounds_origin + 1,     &
+                                  count = value_counts )
+       ELSEIF ( PRESENT( values_int32_1d ) )  THEN
+          nc_stat = NF90_PUT_VAR( file_id, variable_id, values_int32_1d,    &
+                                  start = bounds_start - bounds_origin + 1, &
+                                  count = value_counts )
+       ELSEIF ( PRESENT( values_int32_2d ) )  THEN
+          nc_stat = NF90_PUT_VAR( file_id, variable_id, values_int32_2d,    &
+                                  start = bounds_start - bounds_origin + 1, &
+                                  count = value_counts )
+       ELSEIF ( PRESENT( values_int32_3d ) )  THEN
+          nc_stat = NF90_PUT_VAR( file_id, variable_id, values_int32_3d,    &
+                                  start = bounds_start - bounds_origin + 1, &
+                                  count = value_counts )
+!
+!--    working-precision integer output
+       ELSEIF ( PRESENT( values_intwp_0d ) )  THEN
+          nc_stat = NF90_PUT_VAR( file_id, variable_id, (/ values_intwp_0d /),  &
+                                  start = bounds_start - bounds_origin + 1,     &
+                                  count = value_counts )
+       ELSEIF ( PRESENT( values_intwp_1d ) )  THEN
+          nc_stat = NF90_PUT_VAR( file_id, variable_id, values_intwp_1d,    &
+                                  start = bounds_start - bounds_origin + 1, &
+                                  count = value_counts )
+       ELSEIF ( PRESENT( values_intwp_2d ) )  THEN
+          nc_stat = NF90_PUT_VAR( file_id, variable_id, values_intwp_2d,    &
+                                  start = bounds_start - bounds_origin + 1, &
+                                  count = value_counts )
+       ELSEIF ( PRESENT( values_intwp_3d ) )  THEN
+          nc_stat = NF90_PUT_VAR( file_id, variable_id, values_intwp_3d,    &
+                                  start = bounds_start - bounds_origin + 1, &
+                                  count = value_counts )
+!
+!--    32bit real output
+       ELSEIF ( PRESENT( values_real32_0d ) )  THEN
+          nc_stat = NF90_PUT_VAR( file_id, variable_id, (/ values_real32_0d /), &
+                                  start = bounds_start - bounds_origin + 1,     &
+                                  count = value_counts )
+       ELSEIF ( PRESENT( values_real32_1d ) )  THEN
+          nc_stat = NF90_PUT_VAR( file_id, variable_id, values_real32_1d,   &
+                                  start = bounds_start - bounds_origin + 1, &
+                                  count = value_counts )
+       ELSEIF ( PRESENT( values_real32_2d ) )  THEN
+          nc_stat = NF90_PUT_VAR( file_id, variable_id, values_real32_2d,   &
+                                  start = bounds_start - bounds_origin + 1, &
+                                  count = value_counts )
+       ELSEIF ( PRESENT( values_real32_3d ) )  THEN
+          nc_stat = NF90_PUT_VAR( file_id, variable_id, values_real32_3d,   &
+                                  start = bounds_start - bounds_origin + 1, &
+                                  count = value_counts )
+!
+!--    64bit real output
+       ELSEIF ( PRESENT( values_real64_0d ) )  THEN
+          nc_stat = NF90_PUT_VAR( file_id, variable_id, (/ values_real64_0d /), &
+                                  start = bounds_start - bounds_origin + 1,     &
+                                  count = value_counts )
+       ELSEIF ( PRESENT( values_real64_1d ) )  THEN
+          nc_stat = NF90_PUT_VAR( file_id, variable_id, values_real64_1d,   &
+                                  start = bounds_start - bounds_origin + 1, &
+                                  count = value_counts )
+       ELSEIF ( PRESENT( values_real64_2d ) )  THEN
+          nc_stat = NF90_PUT_VAR( file_id, variable_id, values_real64_2d,   &
+                                  start = bounds_start - bounds_origin + 1, &
+                                  count = value_counts )
+       ELSEIF ( PRESENT( values_real64_3d ) )  THEN
+          nc_stat = NF90_PUT_VAR( file_id, variable_id, values_real64_3d,   &
+                                  start = bounds_start - bounds_origin + 1, &
+                                  count = value_counts )
+!
+!--    working-precision real output
+       ELSEIF ( PRESENT( values_realwp_0d ) )  THEN
+          nc_stat = NF90_PUT_VAR( file_id, variable_id, (/ values_realwp_0d /), &
+                                  start = bounds_start - bounds_origin + 1,     &
+                                  count = value_counts )
+       ELSEIF ( PRESENT( values_realwp_1d ) )  THEN
+          nc_stat = NF90_PUT_VAR( file_id, variable_id, values_realwp_1d,   &
+                                  start = bounds_start - bounds_origin + 1, &
+                                  count = value_counts )
+       ELSEIF ( PRESENT( values_realwp_2d ) )  THEN
+          nc_stat = NF90_PUT_VAR( file_id, variable_id, values_realwp_2d,   &
+                                  start = bounds_start - bounds_origin + 1, &
+                                  count = value_counts )
+       ELSEIF ( PRESENT( values_realwp_3d ) )  THEN
+          nc_stat = NF90_PUT_VAR( file_id, variable_id, values_realwp_3d,   &
+                                  start = bounds_start - bounds_origin + 1, &
+                                  count = value_counts )
+       ELSE
+          return_value = 1
+          nc_stat = NF90_NOERR
+          WRITE( temp_string, '(": variable_id=",I6,", file_id=",I6)' ) variable_id, file_id
+          CALL internal_message( 'error', routine_name // &
+                                 ': no output values given ' // TRIM( temp_string ) )
+       ENDIF
+!
+!--    Check for errors
+       IF ( nc_stat /= NF90_NOERR )  THEN
+          return_value = 1
+
+          IF ( nc_stat == NF90_EEDGE .OR. nc_stat == NF90_EINVALCOORDS )  THEN
+!
+!--          If given bounds exceed dimension bounds, get information of bounds in file
+             WRITE( temp_string, * )  NF90_STRERROR( nc_stat )
+
+             ALLOCATE( dimension_ids(ndims) )
+             ALLOCATE( dimension_lengths(ndims) )
+
+             nc_stat = NF90_INQUIRE_VARIABLE( file_id, variable_id, dimids=dimension_ids )
+
+             d = 1
+             DO WHILE ( d <= ndims .AND. nc_stat == NF90_NOERR )
+                nc_stat = NF90_INQUIRE_DIMENSION( file_id, dimension_ids(d), &
+                                                  LEN=dimension_lengths(d) )
+                d = d + 1
+             ENDDO
+
+             IF ( nc_stat == NF90_NOERR )  THEN
+                WRITE( temp_string, * )  TRIM( temp_string ) // '; given variable bounds: ' //  &
+                   'start=', bounds_start, ', count=', value_counts, ', origin=', bounds_origin
+                CALL internal_message( 'error', routine_name //     &
+                                       ': error while writing: ' // TRIM( temp_string ) )
+             ELSE
+!
+!--             Error occured during NF90_INQUIRE_VARIABLE or NF90_INQUIRE_DIMENSION
+                CALL internal_message( 'error', routine_name //            &
+                                       ': error while accessing file: ' // &
+                                        NF90_STRERROR( nc_stat ) )
+             ENDIF
+
+          ELSE
+!
+!--          Other NetCDF error
+             CALL internal_message( 'error', routine_name //     &
+                                    ': error while writing: ' // NF90_STRERROR( nc_stat ) )
+          ENDIF
+       ENDIF
+
+    ENDIF
+#else
+    return_value = 1
+#endif
+
+ END SUBROUTINE netcdf4_write_variable
 
 !--------------------------------------------------------------------------------------------------!
@@ -751,31 +763,31 @@
 !> Close netcdf file.
 !--------------------------------------------------------------------------------------------------!
-SUBROUTINE netcdf4_finalize( file_id, return_value )
-
-   CHARACTER(LEN=*), PARAMETER ::  routine_name = 'netcdf4_finalize'  !< name of routine
-
-   INTEGER, INTENT(IN)  ::  file_id       !< file ID
-   INTEGER              ::  nc_stat       !< netcdf return value
-   INTEGER, INTENT(OUT) ::  return_value  !< return value
-
-
-#if defined( __netcdf4 )
-   WRITE( temp_string, * ) file_id
-   CALL internal_message( 'debug', routine_name // &
-                          ': close file (file_id=' // TRIM( temp_string ) // ')' )
-
-   nc_stat = NF90_CLOSE( file_id )
-   IF ( nc_stat == NF90_NOERR )  THEN
-      return_value = 0
-   ELSE
-      return_value = 1
-      CALL internal_message( 'error', routine_name // &
-                             ': NetCDF error: ' // NF90_STRERROR( nc_stat ) )
-   ENDIF
-#else
-   return_value = 1
-#endif
-
-END SUBROUTINE netcdf4_finalize
+ SUBROUTINE netcdf4_finalize( file_id, return_value )
+
+    CHARACTER(LEN=*), PARAMETER ::  routine_name = 'netcdf4_finalize'  !< name of routine
+
+    INTEGER, INTENT(IN)  ::  file_id       !< file ID
+    INTEGER              ::  nc_stat       !< netcdf return value
+    INTEGER, INTENT(OUT) ::  return_value  !< return value
+
+
+#if defined( __netcdf4 )
+    WRITE( temp_string, * ) file_id
+    CALL internal_message( 'debug', routine_name // &
+                           ': close file (file_id=' // TRIM( temp_string ) // ')' )
+
+    nc_stat = NF90_CLOSE( file_id )
+    IF ( nc_stat == NF90_NOERR )  THEN
+       return_value = 0
+    ELSE
+       return_value = 1
+       CALL internal_message( 'error', routine_name // &
+                              ': NetCDF error: ' // NF90_STRERROR( nc_stat ) )
+    ENDIF
+#else
+    return_value = 1
+#endif
+
+ END SUBROUTINE netcdf4_finalize
 
 !--------------------------------------------------------------------------------------------------!
@@ -784,43 +796,43 @@
 !> Convert data_type string into netcdf data type value.
 !--------------------------------------------------------------------------------------------------!
-FUNCTION get_netcdf_data_type( data_type ) RESULT( return_value )
-
-   CHARACTER(LEN=*), INTENT(IN) ::  data_type  !< requested data type
-
-   CHARACTER(LEN=*), PARAMETER ::  routine_name = 'get_netcdf_data_type'  !< name of this routine
-
-   INTEGER ::  return_value  !< netcdf data type
-
-
-   SELECT CASE ( TRIM( data_type ) )
-
-#if defined( __netcdf4 )
-      CASE ( 'char' )
-         return_value = NF90_CHAR
-
-      CASE ( 'int8' )
-         return_value = NF90_BYTE
-
-      CASE ( 'int16' )
-         return_value = NF90_SHORT
-
-      CASE ( 'int32' )
-         return_value = NF90_INT
-
-      CASE ( 'real32' )
-         return_value = NF90_FLOAT
-
-      CASE ( 'real64' )
-         return_value = NF90_DOUBLE
-#endif
-
-      CASE DEFAULT
-         CALL internal_message( 'error', routine_name // &
-                                ': data type unknown (' // TRIM( data_type ) // ')' )
-         return_value = -1
-
-   END SELECT
-
-END FUNCTION get_netcdf_data_type
+ FUNCTION get_netcdf_data_type( data_type ) RESULT( return_value )
+
+    CHARACTER(LEN=*), INTENT(IN) ::  data_type  !< requested data type
+
+    CHARACTER(LEN=*), PARAMETER ::  routine_name = 'get_netcdf_data_type'  !< name of this routine
+
+    INTEGER ::  return_value  !< netcdf data type
+
+
+    SELECT CASE ( TRIM( data_type ) )
+
+#if defined( __netcdf4 )
+       CASE ( 'char' )
+          return_value = NF90_CHAR
+
+       CASE ( 'int8' )
+          return_value = NF90_BYTE
+
+       CASE ( 'int16' )
+          return_value = NF90_SHORT
+
+       CASE ( 'int32' )
+          return_value = NF90_INT
+
+       CASE ( 'real32' )
+          return_value = NF90_FLOAT
+
+       CASE ( 'real64' )
+          return_value = NF90_DOUBLE
+#endif
+
+       CASE DEFAULT
+          CALL internal_message( 'error', routine_name // &
+                                 ': data type unknown (' // TRIM( data_type ) // ')' )
+          return_value = -1
+
+    END SELECT
+
+ END FUNCTION get_netcdf_data_type
 
 !--------------------------------------------------------------------------------------------------!
@@ -830,22 +842,22 @@
 !> or creating the error message string.
 !--------------------------------------------------------------------------------------------------!
-SUBROUTINE internal_message( level, string )
-
-   CHARACTER(LEN=*), INTENT(IN) ::  level   !< message importance level
-   CHARACTER(LEN=*), INTENT(IN) ::  string  !< message string
-
-
-   IF ( TRIM( level ) == 'error' )  THEN
-
-      WRITE( internal_error_message, '(A,A)' ) ': ', string
-
-   ELSEIF ( TRIM( level ) == 'debug'  .AND.  print_debug_output )  THEN
-
-      WRITE( debug_output_unit, '(A,A)' ) 'DOM DEBUG: ', string
-      FLUSH( debug_output_unit )
-
-   ENDIF
-
-END SUBROUTINE internal_message
+ SUBROUTINE internal_message( level, string )
+
+    CHARACTER(LEN=*), INTENT(IN) ::  level   !< message importance level
+    CHARACTER(LEN=*), INTENT(IN) ::  string  !< message string
+
+
+    IF ( TRIM( level ) == 'error' )  THEN
+
+       WRITE( internal_error_message, '(A,A)' ) ': ', string
+
+    ELSEIF ( TRIM( level ) == 'debug'  .AND.  print_debug_output )  THEN
+
+       WRITE( debug_output_unit, '(A,A)' ) 'DOM DEBUG: ', string
+       FLUSH( debug_output_unit )
+
+    ENDIF
+
+ END SUBROUTINE internal_message
 
 !--------------------------------------------------------------------------------------------------!
@@ -854,15 +866,15 @@
 !> Return the last created error message.
 !--------------------------------------------------------------------------------------------------!
-FUNCTION netcdf4_get_error_message() RESULT( error_message )
-
-   CHARACTER(LEN=800) ::  error_message  !< return error message to main program
-
-
-   error_message = TRIM( internal_error_message )
-
-   internal_error_message = ''
-
-END FUNCTION netcdf4_get_error_message
-
-
-END MODULE data_output_netcdf4_module
+ FUNCTION netcdf4_get_error_message() RESULT( error_message )
+
+    CHARACTER(LEN=800) ::  error_message  !< return error message to main program
+
+
+    error_message = TRIM( internal_error_message )
+
+    internal_error_message = ''
+
+ END FUNCTION netcdf4_get_error_message
+
+
+ END MODULE data_output_netcdf4_module
